File:          eh-0.5.tar.gz
Author:        Christopher Cobb
Release:       0.5
Compatibility: DR8
Location:      contrib/develop
Notes:

eh is an Error Handler.  It provides an error handling framework 
that is designed to make developing C and C++ software more 
effective and productive.

The Error Handler provides the following features:

   1. RESOURCE TRACKING:  built-in tracking of ANSI resources.
         ANSI C: malloc(), calloc(), realloc(), free(), fopen(), 
                 fclose(), tmpfile(), fclose().
         ANSI C++: operators new and delete.
         Tracking of local resources can be added.

   2. FUNCTION TRACING:  emit messages upon function entry and 
         exit.  Volume of messages can be controlled at runtime.

   3. LOG FILE MANAGEMENT:  send error messages to stderr or log 
         file.  Destination of error messages can be dynamically 
         changed at runtime.  Log files are automatically cycled.

   4. ERROR MESSAGE MANAGEMENT:  error messages can be sent to one 
        of four error "channels".  Volume of messages on each 
        channel can be controlled at runtime.

   5. EXCEPTION HANDLING:  integrated with function tracing to 
        provide a dynamic trace of exception as the exception is 
        being thrown.  The same exception model is used for both
        C++ and C versions of the Error Handler.

   6. CONTROL-C (USER INTERRUPT) HANDLING:  will cleanly and 
        transparently handle user interrupt requests with little or 
        no special coding.  The exception handling model 
        automatically accomodates user interrupts.

   7. TESTING:  built-in support for simulating (difficult-to-cause)
        exceptions.  

Disclaimer
==========

This alpha version (v 0.5) should compile and run in a C++ 
environment.  Although previous versions have been tested 
successfully in C environments, this version has not yet been tested 
for C only.  Likewise, it has been tested in the Posix environment 
but has not been tested in a native BeOS environment.  It is not yet 
fully thread safe (coming soon!) 

Christopher Cobb
Cobb Software Engineering Guild, Inc.
ccobb@cseg.com
