#
# config.site.Solaris.CC -- Solaris w/ Sparc CC compiler
#
# This is a site-wide configuration file.  If it is visible to 
# ./configure it will be use to provide a site-specific environment 
# for ./configure.
#
# The following two ways (among others) may be used to make this file
# visible to ./configure:
#
# 1 -- Copy this file to /usr/local/share/config.site
#      Then invoke ./configure
#
#      If you use the --prefix=/my/installation/dir option to 
#      ./configure, copy this file instead to 
#      $prefix/share/config.site
#      Then invoke ./configure --prefix=/my/installation/dir
#
# 2 -- set the environmental variable CONFIG_SITE to 
#      the pathname of your config.site file.  E.g.,
#         CONFIG_SITE=../eh-n.n/config.site.bebox
#      Then invoke ./configure
#

if [ -n "$CONFIG_SITE" ];then   # method 2 used, set $prefix here
   if [ "$prefix" = NONE ];then # only override default setting
      prefix=/appls             # where to install Error Handler
   fi
fi

CXX="CC"                        # C++ compiler (preferred over C)
CXXFLAGS=""                     # flags for the C++ compiler
CC="CC"                         # C compiler (only if C++ not found)
CFLAGS=""                       # flags for the C compiler
AR="ar"                         # archiver/librarian to build library
ARFLAGS="ru"                    # archiver flags
LDFLAGS=""                      # flags for the C++ linker

# the cache file remembers settings from previous
# runs of configure (speeding things up).  Use
# cache_file=/dev/null to FORGET previous settings.
# Or use cache_file=/my/cache/file to use a site-wide
# cache file that may be used by different packages.
if [ "$cache_file" = ./config.cache ] # only override default setting
then
   cache_file="$prefix/config.cache"  # site-wide cache file
   cache_file="./config.cache"        # default setting
   cache_file="/dev/null"             # no cache file
fi
