/***

lrdirent.h -- Local Resources, directory entries

    Copyright (C) 1997  CSEG, Inc., All rights reserved.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   
 
    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.
 
***/

#ifndef LRPOSIX_H
#define LRPOSIX_H 1
static const char*lrdirent_h =
       "$Id: lrdirent.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EHENV_H
#include "ehenv.h"
#endif

EHBEGINEXTERNC
#include <sys/types.h>
#include <dirent.h>
EHENDEXTERNC

#ifndef   EH_H
#include "eh.h"
#endif

/*** wrapper function prototypes ***/

DIR *_lrOpendir   A((const char *pcFil, const char *pcFun, int iLin,
                     const char *pcDirName));

void _lrClosedir A((const char *pcFil, const char *pcFun, int iLin,
                     DIR*pDir));

/*** wrapper macros ***/

#ifndef LR_NO_DIRENT_TRACKING

#define opendir(dirnam)\
 _lrOpendir(__FILE__, _EHFUNC_, __LINE__, dirnam)

#define closedir(dirp)\
 _lrClosedir(__FILE__, _EHFUNC_, __LINE__, dirp)

#endif /* LR_NO_DIRENT_TRACKING */

#endif /* LRDIRENT_H */
