/***

lrfildes.h -- Local Resources, file descriptors

    Copyright (C) 1997  CSEG, Inc., All rights reserved.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   
 
    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.
 
***/

#ifndef LRFILDES_H
#define LRFILDES_H 1
static const char*lrfildes_h =
       "$Id: lrfildes.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EHENV_H
#include <ehenv.h>
#endif

EHBEGINEXTERNC
#include <stdio.h>
EHENDEXTERNC

#ifndef   EH_H
#include <eh.h>
#endif

/*** wrapper function prototypes  ***/

int  _lrCreat A((const char *pcFil, const char *pcFun, int iLin,
                  const char *pcPath, mode_t mode));

int  _lrOpen  A((const char *pcFil, const char *pcFun, int iLin,
                  const char *pcPath, int iOFlag));

int  _lrDup   A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes));

int  _lrDup2  A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes, int iFilDes2));

void _lrClose A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes));

int  _lrFileno A((const char *pcFil, const char *pcFun, int iLin,
                  FILE *pFile));

int  _lrPipe A((const char *pcFil, const char *pcFun, int iLin,
                  int *piFileDesc));

/*** wrapper macros ***/

#ifndef LR_NO_FILDES_TRACKING

#define creat(path, mode)\
 _lrCreat(__FILE__, _EHFUNC_, __LINE__, path, mode)

#define open(path, flag)\
 _lrOpen(__FILE__, _EHFUNC_, __LINE__, path, flag)

#define dup(fildes)\
 _lrDup(__FILE__, _EHFUNC_, __LINE__, fildes)

#define dup2(fildes, fildes2)\
 _lrDup2(__FILE__, _EHFUNC_, __LINE__, fildes, fildes2)

#define close(fildes)\
 _lrClose(__FILE__, _EHFUNC_, __LINE__, fildes)

#ifdef  fileno /* fileno is often implemented as a macro */
#undef  fileno /* override it with our own macro */
#endif
#define fileno(stream)\
 _lrFileno(__FILE__, _EHFUNC_, __LINE__, stream)

#define pipe(fildes)\
 _lrPipe(__FILE__, _EHFUNC_, __LINE__, fildes)

#endif /* LR_NO_FILDES_TRACKING */

#endif /* LRFILDES_H */
