/***

t_dirent.c -- test driver for directory entry tracking routines

    Copyright (C) 1997  CSEG, Inc., All rights reserved.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   
 
    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.
 
***/

#include <eh.h>
#include "lrdirent.h"

static void opendir_and_closedir();
static void opendir_and_no_closedir();

int
main(int argc, char**argv)
{
   EHMAIN(argc, argv) {

      opendir_and_closedir();
      opendir_and_no_closedir();

   } EHENDMAIN;

   EHRETURN(ehError());
}


static
void
opendir_and_closedir()
{
   DIR*volatile pDir = NULL;

   EHTRY(opendir_and_closedir) {

      pDir = opendir(".");

   } EHCATCH;

   if (pDir) closedir(pDir);
}


static
void
opendir_and_no_closedir()
{
   DIR*volatile pDir = NULL;
   EHTRACE(opendir_and_no_closedir);
   pDir = opendir(".");
}


