/***

ehchnvol.h -- Error Handler, "channel" and "volume" definitions

    Copyright (C) 1997  CSEG, Inc., All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   

    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.

***/

#ifndef EHCHNVOL_H
#define EHCHNVOL_H 1
static const char*ehchnvol_h =
       "$Id: ehchnvol.h,v 1.5 1996/05/12 15:47:27 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EH_H
#include "eh.h"
#endif

/*** imported function declarations ***/

#if (ehSUNOS && !ehSUNC) || (ehPCDOS) || (ehAMIGA && !ehGNUC && !ehDCC)
typedef int pid_t;
#endif

EHBEGINEXTERNC
pid_t getpid A((void));
EHENDEXTERNC

#define EH_NEWDBGVAL 0
#define EH_PIDPREFIX 0xEC000000

/*** volume and channel definitions ***/
#define EH_NUMVOL        4
#define EH_VOL_MASK      0x03  /* only lower 2 are used for volume */
#define EH_FUN_BIT       0x04  /* for activating function tracing  */
#define EH_MEM_MASK      0x18  /* for memory tracing  */
#define EH_BIT_OFFSET    3

#define NO_CHNVOL ((short *)-1)

/*** global variable declarations ***/

extern const char *apcEhChan[EH_NUMCHAN];
extern const char *apcEhVol[EH_NUMVOL];

/*** global function declarations ***/

extern int  ehInitChnVol A((pid_t iPID));
extern void ehTermChnVol A((void));
extern int  ehSetVol A((int iChan, int iVol));
extern int  ehSetFun A((int iChan, int iFunBit));
extern int  ehSetMem A((int iChan, int iMemBit));
extern int  ehSetOut A((int iOutBit));

#if 0
#define ehGetVol(iChan)\
   (phEhChnVol == NO_CHNVOL ? \
   0 : \
   (((int)(*phEhChnVol >> (EH_BITS_PER_CHAN*(iChan)))) & EH_VOL_MASK))
#else
extern int ehGetVol A((int iChan));
#endif

#if 1
#define ehGetFun(iChan)\
   (phEhChnVol == NO_CHNVOL ? 0 : \
   !!((*phEhChnVol >> (EH_BITS_PER_CHAN * iChan)) & EH_FUN_BIT))
#else
extern int ehGetFun A((int iChan));
#endif

#if 0
#define ehGetMem(iChan)\
   (phEhChnVol == NO_CHNVOL ? \
   0 : \
   (((int)(*phEhChnVol >> (EH_BITS_PER_CHAN*(iChan)))) & EH_MEM_MASK))
#else
extern int ehGetMem A((int iChan));
#endif

#endif /* EHCHNVOL_H */
