/***

ehfiltrk.h -- Error Handler, file stream tracking

    Copyright (C) 1997  CSEG, Inc., All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   

    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.

***/

#ifndef EHFILTRK_H
#define EHFILTRK_H 1
static const char*ehfiltrk_h =
       "$Id: ehfiltrk.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EH_H
#include "eh.h"
#endif

/*** file stream tracking support functions ***/

FILE *_ehFopen   A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, const char *mode));

FILE *_ehTmpFile A((const char *pcFil, const char *pcFunc, int iLin));

FILE *_ehFreopen A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, const char *mode, FILE *pFil));

void  _ehFclose  A((const char *pcFil, const char *pcFunc, int iLin,
                  FILE *pFil));

#ifndef EH_NO_FILE_TRACKING

#define fopen(name, mode)\
 _ehFopen(__FILE__, _EHFUNC_, __LINE__, name, mode)

#define tmpfile()\
 _ehTmpFile(__FILE__, _EHFUNC_, __LINE__)

#define freopen(name, mode, pFile)\
 _ehFreopen(__FILE__, _EHFUNC_, __LINE__, name, mode, pFile)

#define fclose(pFile)\
 _ehFclose(__FILE__, _EHFUNC_, __LINE__, pFile)

#endif /* EH_NO_FILE_TRACKING */

#endif /* EHFILTRK_H */
