/***

ehfuntrc.h -- Error Handler, function tracing support

    Copyright (C) 1997  CSEG, Inc., All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   

    The GNU General Public License is in the file COPYING which resides
    in the top directory of the distribution tree.

***/

#ifndef EHFUNTRC_H
#define EHFUNTRC_H 1
static const char*ehfuntrc_h =
       "$Id: ehfuntrc.h,v 1.3 1996/04/12 22:05:47 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EH_H
#include "eh.h"
#endif

#ifndef   EHCHNVOL_H
#include "ehchnvol.h"
#endif

/*** global function declarations ***/

void ehIndent A((FILE * pFile));
void ehLogRet A((int,const char*, const char*, const int));

/*** error handling support ***/

#define EH_SZFILNAM 12 /* "12345678.abc" */
#define EH_SRC_FORMAT   "%serrs.src"
#define EH_HDR_FORMAT   "%serrs.h"
#define EH_MSG_FORMAT   "%serrs.msg"
#define EH_MAXMSGLEN    127      /* maximum message length */

/*** exception handling support ***/

void ehPErrorThrow(const char *pcFunc);

#endif /* EHFUNTRC_H */
