#!/bin/sh
#
# ehtest.sh -- Error Handler, script to test exception handling
#
#   Copyright (C) 1997  CSEG, Inc., All rights reserved.
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                   
#
#   The GNU General Public License is in the file COPYING which resides
#   in the top directory of the distribution tree.
#


searchfor="OVERWRITE|Invalid|invalid|RESOURCE|ASSERT|pML|cookie |still|over|deadbeef|[^_]null[^_]|nmByWhom|TWICE"

sigcount=1
suffix=.mwccD
suffix=

while [ $# != 0 ]
do
   case $1 in
   -f[01] )
      funtrc=$1
      ;;
   -o[01] )
      seelog=$1
      ;;
   -m[01] )
      seemem=$1
      ;;
   -start )
      shift
      sigcount=$1
      ;;
   -once|-once )
      once=$1
      ;;
   -* )
      echo "ehtest.sh: Don't understand option $1" >&2
      exit 1
      ;;
   * )
      if [ -z "$command" ]; then
         program=$1$suffix
         command=$program
      else
         command="$command $1"
      fi
      ;;
   esac
   shift
done

if [ -z "$program" ]; then
   echo 'usage: ehtest.sh <program> [ <args>... ]'
   exit 1
fi

EHVOLUME="$seelog $funtrc $seemem -c2 -f0 -m0"
EHPATH="`pwd`:$EHPATH"
EHNUMLOGFILES=0
EHLOGFILESDIR=/tmp
export EHVOLUME EHPATH EHNUMLOGFILES EHLOGFILESDIR

logext=1
goodexits=0

while [ "$goodexits" -lt "3" ]
do

   echo "------- setting EHSIGCTRLC to $sigcount -------"
   EHSIGCTRLC=$sigcount
   export EHSIGCTRLC

   rm -f $EHLOGFILESDIR/$program.0*
   echo "ehtest.sh $command $funtrc $seelog -start $sigcount -once" > lasttest.sh
   echo $command $options
   $command $options
   exitcode=$?
   if [ $exitcode = 0 ]; then
      goodexits=`expr $goodexits + 1`
   else
      egrep "$searchfor" $EHLOGFILESDIR/$program.0*
      if [ $? = 0 ]; then
         echo ====================================================================
         echo test failed with EHSIGCTRLC set to $sigcount
         echo ====================================================================
         chmod +x lasttest.sh
         exit 1
      fi
      echo "(exit code $exitcode)"
      goodexits=0
   fi
   if [ -n "$once" ]; then
      exit 
   fi
   sigcount=`expr $sigcount + 1`
done


