/***

t_avl.c -- test the avl tree routnes

***/

#include "eh.h"
#include "eherrs.h"
#include "ehmemtrk.h"

EHAVL *pEhAvlInt;

static int  cmpInt      A((const void*, const void*));
static int  delInt      A((const void**));
static void dmpInt      A((FILE*, const void*));
static void add_to_tree A((int iValue));

main(int argc, char **argv)
{
   EHMAIN(argc, argv)
   {
      pfi_pvpv    pfiCompare = cmpInt; // compare function
      pfi_ppv     pfiDelete  = delInt; // delete  function
      pfv_pFilepv pfvDump    = dmpInt; // dump    function
      
      pEhAvlInt = ehAvlInit(pfiCompare, pfiDelete, pfvDump);
      add_to_tree(54);
      add_to_tree(59);
      add_to_tree(64);
      add_to_tree(16);
      add_to_tree(189);
      add_to_tree(225);
      add_to_tree(368);
      add_to_tree(193);
      add_to_tree(170);
      add_to_tree(133);
      add_to_tree(110);
      add_to_tree(116);
      add_to_tree(122);
      ehAvlTerm(pEhAvlInt);

   } EHENDMAIN;
   EHDONE(ehError());
}

static
int
cmpInt A2(
   const void*, pv1,
   const void*, pv2)
{
   return(*(int*)pv1 - *(int*)pv2);
}

static
int
delInt A1(
   const void**, ppv)
{
   EHTRACE(delInt);
   if (*ppv) free((char*)*ppv);
}

static
void
dmpInt A2(
   FILE*, pFile,
   const void*, pv)
{
   fprintf(pFile, "%d", *(int*)pv);
   fflush(pFile);
}

static
void
add_to_tree A1(
   int, iValue)
{
   int *volatile piNew = NULL;

   EHTRY(add_to_tree)
   {
      int *piSrch;

      fprintf(EHSTDOUT, "add_to_tree(%d)\n", iValue);
      ehAvlTreeDump(EHSTDOUT, pEhAvlInt); // dump tree
      fflush(EHSTDOUT);

      /*** search the tree ***/

      piSrch = (int *)ehAvlSrch(pEhAvlInt, (const void*)&iValue);

      if (piSrch == NULL)
      {
         /*** add new entry ***/

         if ((piNew = NEW(int)) == NULL)
            EHTHROW_LEAVE(EH_NEWMACRO);
         *piNew = iValue;

         /* insert new ResFunc into tree */
         ehAvlAdd(pEhAvlInt,
               (void *)piNew,
               (pfi_pvpv)NULL);
      }

   } EHCATCH;

   if (ehError())
   {
      if (piNew) free(piNew);
   }
   EHLEAVE();
}


